Missing python-sendfile dependency breaks GlanceImageService

Bug #1391960 reported by Daniel Stelter-Gliese on 2014-11-12
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Ironic
Invalid
Undecided
Unassigned
ironic (Ubuntu)
Undecided
Unassigned

Bug Description

Ironic fails to deploy using pxe_ssh. ironic node-validate <uuid> fails with:
'NoneType' object has no attribute 'GlanceImageService' (HTTP 500)

ironic-conductor stack trace:
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher Traceback (most recent call last):
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher File "/usr/lib/python2.7/dist-packages/oslo/messaging/rpc/dispatcher.py", line 134, in _dispatch_and_reply
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher incoming.message))
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher File "/usr/lib/python2.7/dist-packages/oslo/messaging/rpc/dispatcher.py", line 177, in _dispatch
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher return self._do_dispatch(endpoint, method, ctxt, args)
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher File "/usr/lib/python2.7/dist-packages/oslo/messaging/rpc/dispatcher.py", line 123, in _do_dispatch
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher result = getattr(endpoint, method)(ctxt, **new_args)
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher File "/usr/lib/python2.7/dist-packages/oslo/messaging/rpc/server.py", line 139, in inner
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher return func(*args, **kwargs)
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher File "/usr/lib/python2.7/dist-packages/ironic/conductor/manager.py", line 978, in validate_driver_interfaces
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher iface.validate(task)
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher File "/usr/lib/python2.7/dist-packages/ironic/drivers/modules/pxe.py", line 301, in validate
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher props)
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher File "/usr/lib/python2.7/dist-packages/ironic/drivers/modules/iscsi_deploy.py", line 362, in validate_glance_image_properties
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher glance_service = service.Service(version=1, context=ctx)
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher File "/usr/lib/python2.7/dist-packages/ironic/common/image_service.py", line 65, in Service
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher service_class = getattr(module, 'GlanceImageService')
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher AttributeError: 'NoneType' object has no attribute 'GlanceImageService'
2014-11-12 17:30:27.480 4338 TRACE oslo.messaging.rpc.dispatcher
2014-11-12 17:30:27.483 4338 ERROR oslo.messaging._drivers.common [-] Returning exception 'NoneType' object has no attribute 'GlanceImageService' to caller

Further investigation revealed that ironic.common.glance_service.base_image_service imports "sendfile", while none of the Ironic packages have a dependency on python-sendfile.

Tested on Ubuntu 14.04 (using backported 14.10 packages for Ironic). Package version: 2014.2-0ubuntu1

Related branches

Dmitry Tantsur (divius) wrote :

pysendfile is in requirements.txt:

c59800ed (Mikhail Durnosvistov 2014-05-07 14:20:17 +0300 23) pysendfile==2.0.0

so something should be wrong with the packaging, moving bug downstream

tags: added: juno-backport-potential
Changed in ironic:
status: New → Invalid
James Page (james-page) on 2015-01-12
Changed in ironic (Ubuntu):
status: New → Fix Released
James Page (james-page) wrote :

Actually not quite fixed - working on that now...

Changed in ironic (Ubuntu):
status: Fix Released → New
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ironic - 2015.1~b1-0ubuntu3

---------------
ironic (2015.1~b1-0ubuntu3) vivid; urgency=medium

  * No change rebuild to fixup detection of pysendfile dependency.
 -- James Page <email address hidden> Mon, 12 Jan 2015 16:05:29 +0000

Changed in ironic (Ubuntu):
status: New → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers